import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import ddf.minim.*; 
import ddf.minim.ugens.*; 
import ddf.minim.spi.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class CleanUp extends PApplet {

GameMode gameMode;





Minim minim;

AudioPlayer meow1;
AudioPlayer meow2;
AudioPlayer meow3;
AudioPlayer suckIn;
AudioPlayer suckIn2;

AudioPlayer bg;

AudioPlayer buttonSound;
AudioPlayer startButtonSound;
AudioPlayer countdown1;
AudioPlayer countdown2;

AudioPlayer roundEnd;

PImage level; //the collision image for the level
PImage displayLevel; //image that ist shown to the player
int [][]dImage = new int [1280][720]; //array for saving the image for collision detection


public void setup() {
  
  frameRate(60);
  

  minim = new Minim(this);
  bg = minim.loadFile("Background.wav"); //passt net so
  
  meow1 = minim.loadFile("meow1.wav");
  meow2 = minim.loadFile("meow2.wav");
  meow3 = minim.loadFile("meow3.wav");
  suckIn = minim.loadFile("suckIn.wav");
  suckIn2 = minim.loadFile("suckIn2.wav");
  
  buttonSound = minim.loadFile("buttonSound.wav"); 
  startButtonSound = minim.loadFile("startButton.wav"); 
  countdown1 = minim.loadFile("countdown_01.wav"); 
  countdown2 = minim.loadFile("countdown_02.wav");
 
  
  roundEnd = minim.loadFile("end_sound.wav"); 
   
   
  gameMode = new GameStart ();
  
}

public void draw() {
  gameMode.draw();
}

public void mouseClicked() {
  gameMode.mouseClicked();
}

public void keyPressed() {
  gameMode.keyPressed();
}

public void keyReleased() {
  gameMode.keyReleased();
}

public void mousePressed() {
  gameMode.mousePressed();
}

public void mouseReleased() {
  gameMode.mouseReleased();
}
class CleanUpGame extends GameMode {

  GameWorld gameWorld;

  // UI attributes ===================================================================

  // last time draw() was called - for animations
  int millisDrawWasLastCalled;
  
  
  float left_p1 = 0;
  float right_p1 = 0;
  float down_p1 = 0;
  float up_p1 = 0;

  float left_p2 = 0;
  float right_p2 = 0;
  float down_p2 = 0;
  float up_p2 = 0;
  
  int typeP1;
  int typeP2;
  int stageType;

  // constructor and methods =========================================================

  CleanUpGame(int _typeP1, int _typeP2, int _stageType) {
    typeP1=_typeP1;
    typeP2=_typeP2;
    stageType=_stageType;
    
    millisDrawWasLastCalled = millis();    
    gameWorld = new GameWorld(typeP1,typeP2,stageType);


  }

  public void draw() {

    int millisNow = millis();
    float timeElapsed = (millisNow - millisDrawWasLastCalled) / 1000.0f; // since the last frame, in seconds.

    // draw, in the Processing world, includes updating the game state - hence, animate all objects from draw()
    gameWorld.draw();

    gameWorld.animate(timeElapsed, up_p1, down_p1, left_p1, right_p1, 
                                   up_p2, down_p2, left_p2, right_p2);
                                  

    millisDrawWasLastCalled = millisNow; 
    
  }
  
  public void  keyPressed()
{
  if (keyCode == 'D') //first players buttons
  {
    right_p1 = 1;
  }
  if (keyCode == 'A')
  {
    left_p1 = -1;
  }
  if (keyCode == 'W')
  {
    up_p1 = 1;
  }
  if (keyCode == 'S') 
  {
    down_p1 = -1;
  }

  if (keyCode == RIGHT) //second players buttons
  {
    right_p2 = 1;
  }
  if (keyCode == LEFT)
  {
    left_p2 = -1;
  }
  if (keyCode == UP)
  {
    up_p2 = 1;
  }
  if (keyCode == DOWN) 
  {
    down_p2 = -1;
  }
}

public void keyReleased()
{
  // Reset our key states to 0 when released.
  if (keyCode == 'D')
  {
    right_p1 = 0;
  }
  if (keyCode == 'A')
  {
    left_p1 = 0;
  }
  if (keyCode == 'W')
  {
    up_p1 = 0;
  }
  if (keyCode == 'S')  
  {
    down_p1 = 0;
  }   

  if (keyCode == RIGHT) //second players buttons
  {
    right_p2 = 0;
  }
  if (keyCode == LEFT)
  {
    left_p2 = 0;
  }
  if (keyCode == UP)
  {
    up_p2 = 0;
  }
  if (keyCode == DOWN) 
  {
    down_p2 = 0;
  }
}

}
class GameEndsMode extends GameMode {

  int winner;
  String title;
  int backgroundColor;
  int points_p1;
  int points_p2;
  PImage endscreen_1 = loadImage("endscreen_1.png");
  PImage endscreen_2 = loadImage("endscreen_2.png");
  PImage neutral = loadImage("bg_screen.png");
  PImage bg_p1= loadImage("bgResult_p1.png");
  PImage bg_p2= loadImage("bgResult_p2.png");


  GameEndsMode(String _title, int _backgroundColor, int _winner, int _points_p1, int _points_p2) {
    title = _title;
    backgroundColor = _backgroundColor;
    winner = _winner;
    points_p1 = _points_p1;
    points_p2 = _points_p2;
    roundEnd.rewind();
    roundEnd.play();

    endscreen_1.resize(1280, 720);
    endscreen_2.resize(1280, 720);
    neutral.resize(1280, 720);
  }
  public void draw() {    
    pushStyle();

    if (winner==1) {
      image(endscreen_1, 0, 0);
    }
    if (winner==2) { 
      image(endscreen_2, 0, 0);
    }
    if (winner==0) {    
      image(neutral, 0, 0);
    }
    pushStyle();
    imageMode(CENTER);
    image(bg_p1, width/4, height/2);
    image(bg_p2, width-(width/4), height/2);
    popStyle();

    textAlign(CENTER, CENTER);
    textSize(80);
    text(title, width/2, height/4);
    textSize(48);

    text("Player 1 Score : " + points_p1, width/4, height/2);

    text("Player 2 Score : " + points_p2, width-(width/4), height/2);

    if (millis() % 1200 < 800) {
      text("Press SPACE to continue.", width/2, height*3/4);
    }
    popStyle();
  }
  public void mouseClicked() {
    startButtonSound.rewind();
    startButtonSound.play();
    gameMode = new StageMenu();
  }
  public void keyPressed() {
    if (key==' ') {
      startButtonSound.rewind();
      startButtonSound.play();
      gameMode = new StageMenu();
    }
  }
}
abstract class GameMode {
  public void draw() { 
  }
  public void mouseClicked() {
  }
  public void keyPressed() {
  }
  public void keyReleased() {
  }
  public void mousePressed() {
  }
  public void mouseReleased() {
  }
  // add other event handling functions as required.
}
abstract class GameObject {

  GameWorld gameWorld;

  GameObject(GameWorld _gameWorld) {
    gameWorld = _gameWorld;
  }

  public void UpdateVelocity() {
  }
  public void CheckPlayerCollision() {
  }
  public void UpdateDirection() {
  }
  public void CollideLevel() {
  }
  public abstract void draw();
}
public void DashedCircle(float radius, int dashWidth, int dashSpacing) {

  int steps = 200;
  int dashPeriod = dashWidth + dashSpacing;
  boolean lastDashed = false;

  for (int i = 0; i < steps; i++) {
    boolean curDashed = (i % dashPeriod) < dashWidth;
    if (curDashed && !lastDashed) {
      beginShape();
    }
    if (!curDashed && lastDashed) {
      endShape();
    }
    if (curDashed) {
      float theta = map(i, 0, steps, 0, TWO_PI);
      vertex(cos(theta) * radius, sin(theta) * radius);
    }
    lastDashed = curDashed;
  }
  if (lastDashed) {
    endShape();
  }
}



class Dust extends GameObject {

  PImage dustSprite = loadImage("dustSprite.png");
  PImage dustSprite_v2= loadImage("dustSprite_v2.png");
  PImage [] sprites = {dustSprite, dustSprite_v2};   //array of sprites for random drawing of dust 
  int dustSprite_index;  //the index that determines the dust sprite to be drawn
  PVector position; 
  float radius;
  boolean suckedIn;
  float dustRotation;

  Dust(GameWorld _gameWorld, float x, float y, float _dustRotation, int _dustSprite_index) {

    super(_gameWorld);
    position = new PVector(x, y); 
    dustRotation = _dustRotation;
    radius = 10;
    suckedIn = false;
    dustSprite_index= _dustSprite_index;
  }

  public void UpdateVelocity(Roomba player1, Roomba player2) {

    PVector toRoomba1 = (player1.position.copy().sub(position.copy()));      //direction dust->player1
    toRoomba1.normalize();

    if (PVector.dist(player1.position, position) < player1.suctionRadius) {    //attraction to player1 if within suction reach      
      position.add(toRoomba1.mult(player1.suctionStrength));
    }

    PVector toRoomba2 = (player2.position.copy().sub(position.copy()));       //direction dust->player2
    toRoomba2.normalize();

    if (PVector.dist(player2.position, position) < player2.suctionRadius) {     //attraction to player2 if within suction reach      
      position.add(toRoomba2.mult(player2.suctionStrength));
    }
  }


  public void draw() {

    pushStyle();
    imageMode(CENTER);
    pushMatrix();
    translate(position.x, position.y);
    rotate(radians(dustRotation));
    image(sprites[dustSprite_index], 0, 0);  


    popMatrix();
    popStyle();
  }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////7////////end of dust code

class Roomba extends GameObject {

  float dampingFactor = 0.4f;

  PVector position;
  PVector direction;
  PVector velocity;
  PVector stoss;
  float rotateSpeed;
  float speed;
  int radius;
  float maxSpeed;
  float accel;
  float suctionRadius;
  float mass;
  float suctionStrength;
  int type;

  boolean hasCat = false;

  int outlineColor = (0);

  int minFreq;

  PImage roombaSprite;
  PImage catOnTop = loadImage("neko_onTop.png");
  PImage specSprite; // sprite which defines type of roomba


  Roomba(GameWorld _gameWorld, float x, float y, PVector _direction, PImage _roombaSprite) {

    super(_gameWorld);
    position = new PVector(x, y);
    direction = _direction;
    velocity = new PVector (0.0f, 0.0f);
    stoss = new PVector (0.0f, 0.0f);
    speed = 0;
    roombaSprite = _roombaSprite;
  }  


  public void UpdateVelocity(float deltaTimeSeconds, float up, float down) {


    float speed2 = (accel * (deltaTimeSeconds*deltaTimeSeconds)) * (up + down) ; //speed gets added by time-squared but only if a key is pressed
    speed += speed2;

    speed *= pow(dampingFactor, deltaTimeSeconds);

    if (speed > maxSpeed) {
      speed = maxSpeed;
    }


    velocity.x = direction.x * (speed);
    velocity.y = direction.y * (speed);


    stoss.mult(pow(dampingFactor, deltaTimeSeconds));

    if (stoss.mag() < 0.00001f) {  
      stoss = new PVector (0, 0);
    }

    position.add(velocity).add(stoss);
  }


  public void CheckPlayerCollision(Roomba otherRoomba) { 

    float distance = PVector.dist(position, otherRoomba.position);

    PVector movement_p1 = velocity.copy().add(stoss);
    PVector otherMovement_p2 = otherRoomba.velocity.copy().add(otherRoomba.stoss);  //gesamtBewegung der Spieler (eigenbewegung + bewegung von stössen)


    if (distance < (radius + otherRoomba.radius)) {


      float nx = (position.x - otherRoomba.position.x) / distance; 
      float ny = (position.y - otherRoomba.position.y) / distance;
      float p = 2 * (otherMovement_p2.x * nx + otherMovement_p2.y * ny - movement_p1.x * nx - movement_p1.y * ny) / (otherRoomba.mass + mass);


      PVector v1 = new PVector ((movement_p1.x + p * otherRoomba.mass * nx), (movement_p1.y + p * otherRoomba.mass * ny ));
      PVector v2 = new PVector ((otherMovement_p2.x - p * mass * nx), (otherMovement_p2.y - p * mass * ny ));

      otherRoomba.speed = 0;
      speed = 0;

      stoss = v1;
      otherRoomba.stoss = v2;
    }
  }


  public void UpdateDirection(float left, float right, float deltaTimeSeconds) {


    direction.rotate(rotateSpeed * (left + right) * deltaTimeSeconds);
  }


  //collision with the colored collision image
  public void CollideLevel() {
    PVector priorVelocity = velocity.copy().add(stoss.copy());
    //collision with a wall on the left
    for (int i =0; i<=radius; i++) {
      if (dImage[(int)position.x-i][(int)position.y]==color(0, 255, 0) ) {

        if (priorVelocity.x < 0) {                            
          stoss.x = priorVelocity.x*-1+0.25f;
        }
        speed = 0;
        stoss.y = priorVelocity.y;
      }
    }
    //collision with a wall on the right
    for (int i =0; i<=radius; i++) {
      if (dImage[(int)position.x+i][(int)position.y]==color(0, 255, 255) ) {

        if (priorVelocity.x > 0) {                            
          stoss.x = priorVelocity.x*-1-0.25f;
        }
        speed = 0;
        stoss.y = priorVelocity.y;
      }
    }
    //collision with wall facing up
    for (int i =0; i<=radius; i++) {
      if (dImage[(int)position.x][(int)position.y+i]==color(255, 255, 0) ) {

        if (priorVelocity.y > 0) {                            
          stoss.y = priorVelocity.y*-1-0.25f;
        }
        speed = 0;
        stoss.x = priorVelocity.x;
      }
    }
    //collision with wall facing down
    for (int i =0; i<=radius; i++) {
      if (dImage[(int)position.x][(int)position.y-i]==color(255, 0, 0) ) {

        if (priorVelocity.y < 0) {                            
          stoss.y = priorVelocity.y*-1+0.25f;
        }
        speed = 0;
        stoss.x = priorVelocity.x;
      }
    }
  }

  public void draw() {
    pushStyle();
    imageMode(CENTER);

    pushMatrix();
    translate(position.x, position.y);
    rotate(direction.heading());    

    ellipseMode(RADIUS);
    //fill(0);
    roombaSprite.resize(PApplet.parseInt(radius*2.5f), PApplet.parseInt(radius*2.5f));
    image(roombaSprite, 0, 0);
    specSprite.resize(PApplet.parseInt(radius*2.5f), PApplet.parseInt(radius*2.5f));
    image(specSprite, 0, 0);


    if (hasCat) {

      catOnTop.resize(PApplet.parseInt(radius*2.5f), PApplet.parseInt(radius*2.5f));
      image(catOnTop, 0, 0);
    }


    noFill(); 
    stroke(outlineColor);
    DashedCircle(suctionRadius, 5, 5);

    popMatrix();
    popStyle();
  }
} 

class RoombaSpeedy extends Roomba {


  RoombaSpeedy(GameWorld _gameWorld, float x, float y, PVector _direction, PImage _roombaSprite) {

    super(_gameWorld, x, y, _direction, _roombaSprite);

    rotateSpeed = 4;
    radius = 25;
    accel = 190;
    suctionRadius = 45;
    mass = 0.8f;
    suctionStrength = 1.1f;
    type = 1;

    maxSpeed = 12;

    minFreq = 150;
    specSprite= loadImage("roombaSpeedy.png");
  }
}

class RoombaSucc extends Roomba {


  RoombaSucc(GameWorld _gameWorld, float x, float y, PVector _direction, PImage _roombaSprite) {

    super(_gameWorld, x, y, _direction, _roombaSprite);

    rotateSpeed = 3;
    radius = 30;
    accel = 150;
    suctionRadius = 65;
    mass = 1;
    suctionStrength = 1.4f;
    type = 2;

    maxSpeed = 10;
    minFreq = 120;
    specSprite= loadImage("roombaSucc.png");
  }
}

class RoombaHeavy extends Roomba {


  RoombaHeavy(GameWorld _gameWorld, float x, float y, PVector _direction, PImage _roombaSprite) {

    super(_gameWorld, x, y, _direction, _roombaSprite);

    rotateSpeed = 2;
    radius = 35;
    accel = 100;
    suctionRadius = 55;
    mass = 10;
    suctionStrength = 1.5f;
    type = 3;


    maxSpeed = 6;
    minFreq = 100;
    specSprite= loadImage("roombaHeavy.png");
  }
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////end of roomba code

class PowerUp extends GameObject { 

  PImage itemSprite_speed = loadImage("speed_powerUp.png"); 
  PImage itemSprite_suck = loadImage("suck_powerUp.png"); 
  PImage itemSprite_punch = loadImage("punch_powerUp.png"); 
  PImage itemSprite_neko = loadImage("neko_powerUp.png"); 
  PVector position;
  boolean suckedIn = false;
  float timeActive;
  int type;

  float minOutline;
  float maxOutline;
  float outline;
  int outlineColor = color(0);

  PowerUp(GameWorld _gameWorld, float x, float y, int _type, boolean _suckedIn) {

    super(_gameWorld);
    position = new PVector (x, y);
    suckedIn = _suckedIn;
    timeActive = 5;
    type = _type;

    minOutline = 30;
    maxOutline = 55;
    outline = minOutline;
  }

  public void UpdateVelocity(Roomba player1, Roomba player2) {

    PVector toRoomba1 = (player1.position.copy().sub(position.copy()));      //direction item->player1
    toRoomba1.normalize();

    if (PVector.dist(player1.position, position) < player1.suctionRadius) {    //attraction to player1 if within suction reach      
      position.add(toRoomba1.mult(player1.suctionStrength));
    }

    PVector toRoomba2 = (player2.position.copy().sub(position.copy()));       //direction item->player2
    toRoomba2.normalize();

    if (PVector.dist(player2.position, position) < player2.suctionRadius) {     //attraction to player2 if within suction reach      
      position.add(toRoomba2.mult(player2.suctionStrength));
    }
  } 
  public void draw() {

    pushStyle();
    imageMode(CENTER);
    pushMatrix();
    translate(position.x, position.y);
    strokeWeight(1.5f);

    switch(type) {  

    case 1 :  

      itemSprite_suck.resize(50, 50);
      image(itemSprite_suck, 0, 0);
      outlineColor = color(0, 255, 255);
      break;

    case 2 :
      itemSprite_speed.resize(50, 50);
      image(itemSprite_speed, 0, 0);
      outlineColor = color(255, 0, 0);
      break;

    case 3 :
      itemSprite_neko.resize(50, 50);
      image(itemSprite_neko, 0, 0);
      outlineColor = color(0, 0, 0);
      break;

    case 4 :
      itemSprite_punch.resize(50, 50);
      image(itemSprite_punch, 0, 0);
      outlineColor = color(255, 255, 50);
      break;
    }

    noFill();
    //ellipse(0, 0, outline, outline);  //Halo effect for power ups
    //ellipse(0, 0, outline+15, outline+15);
    stroke(outlineColor);
    DashedCircle(outline, 4, 10);
    DashedCircle(outline-15, 5, 5);

    popMatrix();
    popStyle();
  }
} 
class GameStart extends GameMode {
  PFont pixel;
  PImage titleScreen;

  GameStart() {
    pixel = createFont("Menuetto.ttf", 80); 
    titleScreen= loadImage("Clean_Up_titlescreen.png");
  }
  public void draw() {


    pushStyle();
    background (0xff000080);
    image(titleScreen, 0, 0);
    titleScreen.resize(1344, 756);
    fill(255);
    if (millis() % 1200 < 800) {
      textAlign(CENTER, CENTER);
      textSize(64);
      textFont(pixel);
      text("GAME START", width/2, height-height/4);
    }
    popStyle();
  }
  public void mouseClicked() {
    startButtonSound.rewind();
    startButtonSound.play();
    gameMode = new StageMenu();
  }
  public void keyPressed() {
    if (key==' ') {
      startButtonSound.rewind();
      startButtonSound.play();
      gameMode = new StageMenu();
    }
  }
}
class GameWorld {

  java.util.LinkedList<GameObject> gameObjects; 
  java.util.LinkedList<Dust> dustObjects;
  java.util.LinkedList<Dust> dustToKeep;// all game objects
  java.util.LinkedList<PowerUp> powerUps;

  Roomba player1;
  Roomba player2;
  Roomba reference;
  int typeP1;
  int typeP2;
  int stageType;
  PVector startPosP1;
  PVector startPosP2;
  PVector startDirP1;
  PVector startDirP2;

  int points_p1 = 0;
  int points_p2 = 0;

  int counter = 0; //image stuff
  int i = 0;

  float roundTime = 45; //Timer stuff
  float millisInstanced = millis();
  float remainingTime;
  float lastTicked;
  boolean secondTick = false;

  ///////////////////item effects
  float secondsPickedUp = roundTime*2;
  float secondsPickedUp2 = roundTime*2;  //when was the powerUp picked up, start with any value higher than the roundtime
  float itemTimeActive;
  float itemTimeActive2;

  /////////////item Spawning
  int xCord = PApplet.parseInt(random(0, width));
  int yCord = PApplet.parseInt(random(0, height));  
  int minWallDist = 100;
  int maxItems = 2;
  float itemSpawnRate = 10; //1 is a good value for gameplay, 20 a good one for testing

  PImage dustSprite = loadImage("dustSprite.png");
  
  PImage level_3_top = loadImage("room_3_design_ontop.png"); //image that is drawn over the roombas

  ///////////sound stuff
  Oscil waveP1;
  Oscil waveP2;
  AudioOutput out;
  float maxRoombaLoudness = 0.1f; 


  GameWorld(int _typeP1, int _typeP2, int _stageType) {

    typeP1=_typeP1;
    typeP2=_typeP2;
    stageType = _stageType;

    switch(stageType) {
    case 1:
      level = loadImage("room_1_collision.png");
      displayLevel = loadImage("room_1_design.png");
      startPosP1 = new PVector(80, 630);
      startPosP2 = new PVector(1200, 80);
      startDirP1 = new PVector(0, -1);
      startDirP2 = new PVector(0, 1);
      break;

    case 2:
      level = loadImage("room_2_collision.png");
      displayLevel = loadImage("room_2_design.png");
      startPosP1 = new PVector(80, 630);
      startPosP2 = new PVector(1200, 630);
      startDirP1 = new PVector(0, -1);
      startDirP2 = new PVector(0, -1);
      break;

    case 3:
      level = loadImage("room_3_collision.png");
      displayLevel = loadImage("room_3_design.png");
      startPosP1 = new PVector(80, 645);
      startPosP2 = new PVector(1200, 645);
      startDirP1 = new PVector(0, -1);
      startDirP2 = new PVector(0, -1);
      break;
    }

    displayLevel.resize(1280, 720);
    level.resize(1280, 720);
    level.loadPixels();
    level_3_top.resize(1280, 720);

    PImage roomba_p1_sprite = loadImage("roombaSprite_p1.png");
    PImage roomba_p2_sprite = loadImage("roombaSprite_p2.png");

    gameObjects = new java.util.LinkedList<GameObject>();
    dustObjects = new java.util.LinkedList<Dust>();    
    powerUps = new java.util.LinkedList<PowerUp>();

    player1 = spawnPlayer(typeP1, startPosP1, startDirP1, roomba_p1_sprite);
    player2 = spawnPlayer(typeP2, startPosP2, startDirP2, roomba_p2_sprite);

    gameObjects.add(player1);
    gameObjects.add(player2);

    directionImage();
    dircetionColorsImage();
    spawnDust();

    out = minim.getLineOut(); //create an AudioOutput 

    waveP1 = new Oscil(player1.minFreq, 0, Waves.SAW);
    waveP1.patch(out); 
    waveP2 = new Oscil(player2.minFreq, 0, Waves.SAW);
    waveP2.patch(out);

    bg.rewind();
    //bg.play();
  }

  public Roomba spawnPlayer(int type, PVector startPos, PVector startDir, PImage sprite) {


    switch (type) {
    case 1:
      return new RoombaSpeedy(this, startPos.x, startPos.y, startDir, sprite);  

    case 2:
      return new RoombaSucc(this, startPos.x, startPos.y, startDir, sprite);

    default:
      return new RoombaHeavy(this, startPos.x, startPos.y, startDir, sprite);
    }
  }


  public void animate(float deltaTimeSeconds, float up_p1, float down_p1, float left_p1, float right_p1, 
    float up_p2, float down_p2, float left_p2, float right_p2 ) {


    player1.UpdateVelocity(deltaTimeSeconds, up_p1, down_p1);
    player2.UpdateVelocity(deltaTimeSeconds, up_p2, down_p2);

    player1.UpdateDirection(left_p1, right_p1, deltaTimeSeconds);
    player2.UpdateDirection(left_p2, right_p2, deltaTimeSeconds);

    player1.CollideLevel();
    player2.CollideLevel();

    player1.CheckPlayerCollision(player2);

    AdaptSound(player1, player2);

    HandlePowerUps(deltaTimeSeconds);
    HandleDust();    
    ResetCheck();
    CheckGameEnd();
  }


  public void draw() {     
    pushStyle();
    pushMatrix();

   
    image(displayLevel, 0, 0);


    //Draw Dust
    for (GameObject d : dustObjects) {
      d.draw();
    }
    // Draw PowerUps
    for (PowerUp p : powerUps) {
      p.draw();
    }

    //Draw Players
    for (GameObject o : gameObjects) {
      o.draw();
    }  

    //Scoreboard:
    remainingTime = PApplet.parseInt(roundTime - Timer());
    textAlign(CENTER,CENTER);
    fill(255);
    textSize(35);
    fill(255, 0, 0);
    text("Player 1 : " + points_p1, width/10, height/80);
    fill(0, 0, 255);
    text("Player 2 : " + points_p2, 8.5f*width/10, height/80);
    fill(255);


    if (PApplet.parseInt(roundTime - Timer()) <= 10) { //if under 10 seconds, 

      if (PApplet.parseInt(roundTime - Timer()) % 2 == 1) { //TimeCounter will blink red every 2 seconds
        fill(255, 255, 0); //color of winner? other color than red?
      }

      if ((millis() - lastTicked) > 1000) { //and play a sound

        if (!secondTick) {
          countdown1.rewind();
          countdown1.play();
          secondTick = true;
        } else {
          countdown2.rewind();
          countdown2.play();
          secondTick = false;
        }

        lastTicked = millis();
      }
    }   
    text(PApplet.parseInt(roundTime - Timer()), width/2, 10);  

    if ( stageType==3) {
      image(level_3_top, 0, 0);
    }

    popStyle();
    popMatrix();
  }


  public void CheckGameEnd() {

    if (remainingTime <= 0 || dustObjects.size() == 0) {    

      waveP1.unpatch(out);
      waveP2.unpatch(out); 

      bg.pause();


      if (points_p1>points_p2) {
        gameMode = new GameEndsMode("You Win, Player 1", color(255, 0, 0), 1, points_p1, points_p2);
      } 
      if (points_p2>points_p1) {
        gameMode = new GameEndsMode("You Win, Player 2", color(0, 255, 0), 2, points_p1, points_p2);
      }
      if (points_p2==points_p1) {
        gameMode = new GameEndsMode("DRAW!!!", color(125), 0, points_p1, points_p2);
      }
    }
  }

//calculation where the walls are and writing it in a 2D array and coloring horizontal walls black and vertical walls white
  public void directionImage() {

    for (int y =0; y<level.height; y++) {
      for (int x=0; x<level.width; x++) {
        if (level.get(x, y)==color(0, 0, 0, 0)&&level.get(x+1, y)==color(0, 0, 0, 0)) {
          dImage [x][y]=color(0, 0, 0, 0);
          counter++;
        } else {
          dImage [x][y]=color(abs(red(level.get(x, y))-red(level.get(x+1, y))));

          // println(counter, (abs(red(level.get(x, y))-red(level.get(x+1, y)))), x, y, red(level.get(x+1, y)), red(level.get(1, y)) );
          counter++;
        }
      }
    }
    counter = 0;
  }

//taking the image from above to color the walls in four different colors to know in which direction the Roomba has to be pushed back when colliding with a wall

  public void dircetionColorsImage() {
    for (int y =0; y<level.height; y++) {
      for (int x=0; x<level.width; x++) {
        try {
          if (dImage[x][y]==color(255) && dImage[x+1][y]==color(0, 0, 0, 0)) {
            dImage[x][y]=color(0, 255, 0);
          } else if (dImage[x][y]==color(255) && dImage[x-1][y]==color(0, 0, 0, 0)) {
            dImage[x][y]=color(0, 255, 255);
          } else if (dImage[x][y]==color(0) && dImage[x][y+1]==color(0, 0, 0, 0)) {
            dImage[x][y]=color(255, 0, 0);
          } else if (dImage[x][y]==color(0) && dImage[x][y-1]==color(0, 0, 0, 0)) {
            dImage[x][y]=color(255, 255, 0);
          }
        }
        catch(Exception e) {
          continue;
        }
      }
    }
  }

//filling the level up with dust while taking into consideration where the Roomba and walls are 
  public void spawnDust() {

    Dust dust;

    for (int x = 0; x<1210; x+=50) {
      for (int y = 0; y<720; y+=50) {

        try {
          if ( dImage[x-(dustSprite.height/3)][y-(dustSprite.height/3)]==color(0)
            || dImage[x+(dustSprite.height/3)][y+(dustSprite.height/3)]==color(0) 
            || dImage[x-(dustSprite.height/3)][y+(dustSprite.height/3)]==color(0)
            || dImage[x+(dustSprite.height/3)][y-(dustSprite.height/3)]==color(0)
            || dImage[x][y]==color(0)
            || player1.position.dist(new PVector(x, y)) < dustSprite.height + (player1.radius+player2.radius)/2
            || player2.position.dist(new PVector(x, y)) < dustSprite.height + (player1.radius+player2.radius)/2
            ) {
          } else {
            dust = new Dust(this, x+random(-5, 5), y+random(-5, 5), random(360), PApplet.parseInt (random(2)));
            dustObjects.add(dust);
            i++;
          }
        }
        catch(Exception e) {
          continue;
        }
      }
    }
  } 

  public void AdaptSound(Roomba player1, Roomba player2) {

    float newFreqP1 = map(player1.speed, 0, player1.maxSpeed, player1.minFreq, player1.minFreq+50);
    float newFreqP2 = map(player2.speed, 0, player2.maxSpeed, player2.minFreq, player2.minFreq+50);

    waveP1.setFrequency(newFreqP1);
    waveP2.setFrequency(newFreqP2);

    float newAmpP1 = map(player1.speed, 0, player1.maxSpeed, 0, maxRoombaLoudness);
    float newAmpP2 = map(player2.speed, 0, player2.maxSpeed, 0, maxRoombaLoudness);

    waveP1.setAmplitude(newAmpP1);
    waveP2.setAmplitude(newAmpP2);
  }

  public void HandleDust() { //bewegung, kollision und löschen von staub

    java.util.LinkedList<Dust>dustToKeep = new java.util.LinkedList<Dust>();  

    for (Dust d : dustObjects) {   

      d.UpdateVelocity(player1, player2);

      testDustCollision(player1, player2, d);

      if ( !d.suckedIn) {

        dustToKeep.add(d);
      } 

      dustObjects = dustToKeep;
    }
  }

  public void testDustCollision(Roomba player1, Roomba player2, Dust dust) {

    if (PVector.dist(player1.position, dust.position) < player1.radius * 0.65f) {

      dust.suckedIn = true;
      points_p1 += 1;
    }

    if (PVector.dist(player2.position, dust.position) < player2.radius * 0.65f) {

      dust.suckedIn = true;

      points_p2 += 1;
    }
  }


  public int Timer() {
    int secondsPassed = PApplet.parseInt((millis() - millisInstanced )/1000);
    return secondsPassed;
  }


  public void HandlePowerUps(float deltaTimeSeconds) { //bewegung, kollision und löschen von powerUps

    if (powerUps.size() < maxItems && random(1) < itemSpawnRate * deltaTimeSeconds) {
      SpawnPowerUp();
    }

    java.util.LinkedList<PowerUp>powerUpsToKeep = new java.util.LinkedList<PowerUp>();  

    if (powerUps.size() > 0) {
      for (PowerUp p : powerUps) {

        p.UpdateVelocity(player1, player2);     
        testPowerUpCollision(player1, player2, p);

        p.outline += 15*deltaTimeSeconds;
        if (p.outline > p.maxOutline) {
          p.outline = p.minOutline;
        }

        if (!p.suckedIn) {  

          powerUpsToKeep.add(p);
        }
      }
      powerUps = powerUpsToKeep;
    }
  }


  public void SpawnPowerUp() { //mit globalem bool lösen? und nacheinander die abfragen tötigen solang dieser true ist?

    int checkPlace = 0;

    xCord = PApplet.parseInt(random(50, width-50)); //random placement in whole map
    yCord = PApplet.parseInt(random(50, height-50));


    PVector powerUpPosition = new PVector(xCord, yCord);

    for (i = 0; i < minWallDist; i++)

    try { 
      if (dImage[xCord-i][yCord-i]!=color(0)
        && dImage[xCord+i][yCord+i]!=color(0) 
        && dImage[xCord-i][yCord+i]!=color(0)
        && dImage[xCord+i][yCord-i]!=color(0)
        && dImage[xCord][yCord]!=color(0)
        ) { 

        checkPlace += 1; 
        if (checkPlace == minWallDist) {
        }

        if ( checkPlace == minWallDist 
          && powerUpPosition.dist(player1.position) > minWallDist*2 
          && powerUpPosition.dist(player2.position) > minWallDist*2) {

          PowerUp powerUp = new PowerUp(this, xCord, yCord, PApplet.parseInt(random(1, 4.9f)), false) ;
          powerUps.add(powerUp);

          /*  if (powerUp.type == 3) { //geräusch beim spawnen der katze?
           meow3.rewind();
           meow3.play();
           }
           */
        }
      } else {
        break;
      }
    }
    catch(Exception e) {
    }
  }


  public void testPowerUpCollision(Roomba player1, Roomba player2, PowerUp powerUp) {

    if (PVector.dist(player1.position, powerUp.position) < player1.radius * 0.65f) {

      secondsPickedUp = remainingTime;
      itemTimeActive = powerUp.timeActive; 
      PowerUpEffects(player1, powerUp);
    }

    if (PVector.dist(player2.position, powerUp.position) < player2.radius * 0.65f) {


      secondsPickedUp2 = remainingTime;      
      itemTimeActive2 = powerUp.timeActive; 
      PowerUpEffects(player2, powerUp);
    }
  }


  public void PowerUpEffects(Roomba player, PowerUp powerUp) { 

    ResetStats(player, player.type);
    //sammelt man 2 items, verliert das erste seinen effekt!
    player.outlineColor = powerUp.outlineColor;

    switch(powerUp.type) 
    {
    case 1:
      println("extra Succcccc");
      player.accel *= 0.75f;
      player.suctionRadius *= 1.5f;
      player.suctionStrength *= 1.7f; 

      suckIn.rewind();
      suckIn.play();

      break;

    case 2:
      println("plusSpeed");
      player.accel *= 2;
      player.rotateSpeed *= 1.3f;
      player.maxSpeed *= 2;
      player.minFreq += 50;

      suckIn.rewind();
      suckIn.play();

      break;

    case 3:
      println("plusGATO");
      player.mass *= 2;
      player.accel *= 0.6f;
      player.maxSpeed *= 0.4f;
      player.hasCat = true;

      meow1.rewind();
      meow1.play();
      break;

    case 4:
      println("plusWUMMS");
      player.mass *= 4;
      player.accel *= 1.2f;

      suckIn.rewind();
      suckIn.play();

      break;
    }

    powerUp.suckedIn = true;
  }


  public void ResetCheck() { 

    if (!PowerUpTimer(itemTimeActive, secondsPickedUp)) {
      ResetStats(player1, player1.type);
    }
    if (!PowerUpTimer(itemTimeActive2, secondsPickedUp2)) {
      ResetStats(player2, player2.type);
    }
  }


  public void ResetStats(Roomba player, int type) {

    switch(type)
    {
    case 1:
      reference = new RoombaSpeedy(this, 0, 0, new PVector(0, 0), dustSprite);
      break;

    case 2:
      reference = new RoombaSucc(this, 0, 0, new PVector(0, 0), dustSprite);
      break;

    case 3:
      reference = new RoombaHeavy(this, 0, 0, new PVector(0, 0), dustSprite);
      break;
    }

    if (player.hasCat) { //if the player had the cat item, reset that
      meow2.rewind();
      meow2.play();
      player.hasCat = false;
    }

    player.rotateSpeed = reference.rotateSpeed;   
    player.accel = reference.accel;
    player.suctionRadius = reference.suctionRadius;
    player.mass = reference.mass;
    player.suctionStrength = reference.suctionStrength;
    player.maxSpeed = reference.maxSpeed;
    player.outlineColor = (0);
    player.minFreq = reference.minFreq;
  }


  public boolean PowerUpTimer(float timeActive, float secondsPickedUp) {

    if (remainingTime < secondsPickedUp - timeActive) {
      //println(" es ist deaktiviert");
      return false;
    } else {     
      //println("es ist aktiviert");
      return true;
    }
  }
}
class HomeMode extends GameMode {

  java.util.LinkedList<Button> buttons_A; 
  java.util.LinkedList<Button> buttons_B; 

  PImage bgImage;
  PImage controls_p1;
  PImage controls_p2;
  PImage button_p1;
  PImage button_p2;
  PImage button_selected;
  PImage startButton;
  PImage startButtonSelected;
  PImage backButton;
  PImage speedySprite_p1;
  PImage heavySprite_p1;
  PImage succSprite_p1;
  PImage speedySprite_p2;
  PImage heavySprite_p2;
  PImage succSprite_p2;
  PImage buttonSelected;
  PImage backButtonSelected;

  int typeP1; //variable to store Roomba type Player 1 chooses
  int typeP2; //variable to store Roomba type player 2 chosses
  int stageType;

  Button A1;
  Button A2;
  Button A3;

  Button B1;
  Button B2;
  Button B3;

  Button start;
  Button back;
  
  float buttonsHeight;
  int buttonsSize;


  HomeMode(int _stageType) {

    button_p1=loadImage("button_p1.png");
    button_p2=loadImage("button_p2.png");
    buttonSelected = loadImage("buttonSelected.png");

    startButton = loadImage("startButton.png");
    startButtonSelected = loadImage("startButtonSelected.png");

    backButton = loadImage("back_button.png");
    backButtonSelected = loadImage("startButtonSelected.png");
    
    speedySprite_p1 = loadImage("roombaSpriteSpeedy_p1.png");
    succSprite_p1 = loadImage("roombaSpriteSucc_p1.png");
    heavySprite_p1 = loadImage("roombaSpriteHeavy_p1.png");

    speedySprite_p1.resize(100, 100);
    succSprite_p1.resize(150, 150);
    heavySprite_p1.resize(200, 200);

    speedySprite_p2 = loadImage("roombaSpriteSpeedy_p2.png");
    succSprite_p2 = loadImage("roombaSpriteSucc_p2.png");
    heavySprite_p2 = loadImage("roombaSpriteHeavy_p2.png");

    speedySprite_p2.resize(100, 100);
    succSprite_p2.resize(150, 150);
    heavySprite_p2.resize(200, 200);

    buttonsHeight = height/4;
    buttonsSize = 100;

    A1= new ButtonRoomba(width/8, buttonsHeight, buttonsSize, buttonsSize, "SPEEDY", width/8, buttonsHeight, true, 1, button_p1, speedySprite_p1, PApplet.parseInt(2.9f*width/10), buttonSelected);
    A2 = new ButtonRoomba(2*width/8, buttonsHeight, buttonsSize, buttonsSize, "SUCC", 2*width/8, buttonsHeight, false, 2, button_p1, succSprite_p1, PApplet.parseInt(2.9f*width/10), buttonSelected);
    A3 = new ButtonRoomba(3*width/8, buttonsHeight, buttonsSize, buttonsSize, "HEAVY", 3*width/8, buttonsHeight, false, 3, button_p1, heavySprite_p1, PApplet.parseInt(2.9f*width/10), buttonSelected);

    B1 = new ButtonRoomba(4.5f*width/8, buttonsHeight, buttonsSize, buttonsSize, "SPEEDY", 4.5f*width/8, buttonsHeight, true, 1, button_p2, speedySprite_p2, PApplet.parseInt(7.3f*width/10), buttonSelected);
    B2 = new ButtonRoomba(5.5f*width/8, buttonsHeight, buttonsSize, buttonsSize, "SUCC", 5.5f*width/8, buttonsHeight, false, 2, button_p2, succSprite_p2, PApplet.parseInt(7.3f*width/10), buttonSelected);
    B3 = new ButtonRoomba(6.5f*width/8, buttonsHeight, buttonsSize, buttonsSize, "HEAVY", 6.5f*width/8, buttonsHeight, false, 3, button_p2, heavySprite_p2, PApplet.parseInt(7.3f*width/10), buttonSelected);

    start = new Button(46*width/100, 51.5f*height/100, PApplet.parseInt(1.2f*startButton.width/3), PApplet.parseInt(1.2f*startButton.height/3), "", 6.5f*width/8, height/4, false, 3, startButton, startButtonSelected);
    back = new Button(width/25, height/15, backButton.width/3, backButton.height/3, "", 6.5f*width/8, height/4, false, 3, backButton, backButtonSelected);

    buttons_A = new java.util.LinkedList<Button>();
    buttons_B = new java.util.LinkedList<Button>();

    buttons_A.add(A1);
    buttons_A.add(A2);
    buttons_A.add(A3);

    buttons_B.add(B1);
    buttons_B.add(B2);
    buttons_B.add(B3);

    bgImage =loadImage("bg_screen.png");

    controls_p1=loadImage("controls_p1.png");
    controls_p2=loadImage("controls_p2.png");

    controls_p1.resize(PApplet.parseInt(2*controls_p1.width/3), PApplet.parseInt(2*controls_p1.height/3));
    controls_p2.resize(2*controls_p2.width/3, 2*controls_p2.height/3);

    stageType=_stageType;
  }

  public void draw() { 

    image(bgImage, 0, 0);
    bgImage.resize(1280, 720);

    fill(255);
    
    pushStyle();
    textAlign(CENTER,CENTER);
    textSize(60);
    text("Choose your Roomba", width/2, height/12);
    
    popStyle();
    pushStyle();

    for (Button a : buttons_A) {

      a.draw();
    }

    for (Button b : buttons_B) {

      b.draw();
    }

    fill(255, 0, 0);
    textSize(30);
    text("PLAYER 1", width/8, height/5);


    fill(0, 0, 255);
    textSize(30);
    text("PLAYER 2", 4.5f*width/8, height/5);

    //start button and back button
    start.draw();
    back.draw();


    //controls explanation images

    image(controls_p1, width/10, 2.3f*height/3);
    image(controls_p2, 1.7f*width/3, 2.3f*height/3);
    popStyle();
  }

  public void mouseClicked() {

//check if button is pressed
    for (Button a : buttons_A) {

      if (a.overRect()==true) {
        buttonClicked(buttons_A);
      }
    }

    for (Button b : buttons_B) {

      if (b.overRect()==true) {
        buttonClicked(buttons_B);
      }
    }
    if (start.overRect()==true) {
      
      for (Button a : buttons_A) {
        if (a.pressed==true) {

          typeP1=a.type; // saves the type of Roomba that was chosen
        }
      }

      for (Button b : buttons_B) {
        if (b.pressed==true) {
          typeP2=b.type;
        }
      }
      startButtonSound.rewind();
      startButtonSound.play();
      gameMode = new CleanUpGame(typeP1, typeP2, stageType);
    }

    if (back.overRect()==true) {
      startButtonSound.rewind();
      startButtonSound.play();
      gameMode = new StageMenu(); //going back to selecting a stage
    }
  }

}

//Button for the Roomba selection that shows the image of the roomba when pressed
class ButtonRoomba extends Button {

  PImage selectedRoomba;
  int roombaPos;

  ButtonRoomba( float _x, float _y, int _rectWidth, int _rectHeight, String _text, float _textX, float _textY, boolean _pressed, int _type, PImage _buttonImage, PImage _selectedRoomba, int _roombaPos, PImage _buttonSelected) {
    super( _x, _y, _rectWidth, _rectHeight, _text, _textX, _textY, _pressed, _type, _buttonImage, _buttonSelected);
    selectedRoomba = _selectedRoomba;
    roombaPos=_roombaPos;
  }

  public void draw() {
    pushStyle();
    noStroke();
    buttonImage.resize(rectWidth, rectHeight);
    image(buttonImage, x, y);
    if (pressed==true) {
      buttonSelected.resize(rectWidth, rectHeight);
      image(buttonSelected, x, y);
      pushStyle();
      imageMode(CENTER);
      image(selectedRoomba, roombaPos, 5.5f*height/10);
      popStyle();
    }

    textSize(28);
    text(text, textX, textY);

    popStyle();
  }
   
}
class StageMenu extends GameMode {
  java.util.LinkedList<Button> stageButtons; 
  int stageType; //variable to store which stage was chosen

  PImage titleScreen;
  PImage none;
  Button stage1;
  Button stage2;
  Button stage3;

  Button next;

  PImage stageThumb1;
  PImage stageThumb2;
  PImage stageThumb3;
  PImage roombaSelectMenu;

  PImage nextSelected;
  PImage buttonStageSelected;

  int scaleFacWidth;
  int scaleFacHeight;
  int widthres;
  int hight;

  StageMenu() {

    titleScreen = loadImage("bg_screen.png");
    stageThumb1= loadImage("level_1_thumb.png");
    stageThumb2= loadImage("level_2_thumb.png");
    stageThumb3= loadImage("level_3_thumb.png");
    roombaSelectMenu = loadImage("roombaSelectionButton.png");

    nextSelected = loadImage("startButtonSelected.png");
    buttonStageSelected = loadImage("level_selected.png");


    scaleFacWidth =stageThumb1.width/3;
    scaleFacHeight =stageThumb1.height/3;
    hight= height/3;
    widthres = (width/2)-(scaleFacWidth/2);

    stage1=new Button(widthres-400, hight, scaleFacWidth, scaleFacHeight, "LIVING ROOM", widthres-400, hight-10, true, 1, stageThumb1, buttonStageSelected );
    stage2=new Button(widthres, hight, scaleFacWidth, scaleFacHeight, "KITCHEN", widthres, hight-10, false, 2, stageThumb2, buttonStageSelected);
    stage3=new Button(widthres+400, hight, scaleFacWidth, scaleFacHeight, "BATHROOM", widthres+400, hight-10, false, 3, stageThumb3, buttonStageSelected);

    next = new Button(widthres, hight+250, scaleFacWidth, scaleFacHeight, "", widthres, hight+190, false, 1, roombaSelectMenu, nextSelected);

    stageButtons = new java.util.LinkedList<Button>();
    stageButtons.add(stage1);
    stageButtons.add(stage2);
    stageButtons.add(stage3);
  }
  public void draw() {


    pushStyle();

    image(titleScreen, 0, 0);
    titleScreen.resize(1344, 756);
    fill(255);
    textAlign(CENTER, CENTER);
    textSize(64);

    text("CHOOSE YOUR STAGE", width/2, height/6);
    popStyle();
    for (Button a : stageButtons) {

      a.draw();
    }

    next.draw();
  }
  public void mouseClicked() {
    for (Button a : stageButtons) {

      if (a.overRect()==true) {
        buttonClicked(stageButtons);
      }
    }


    if (next.overRect()==true) {

      for (Button a : stageButtons) {
        if (a.pressed==true) {
          startButtonSound.rewind();
          startButtonSound.play();
          gameMode = new HomeMode(a.type);
        }
      }
    }
  }
}
class Button {
  float x;
  float y;
  int rectWidth;
  int rectHeight;
  String text;
  float textX;
  float textY;
  boolean pressed;

  int type; //stores the stage or Roomba type
  PImage buttonImage;
  PImage buttonSelected;



  //general button for start, back , stages etc.
  Button(float _x, float _y, int _rectWidth, int _rectHeight, String _text, float _textX, float _textY, boolean _pressed, int _type, PImage _buttonImage, PImage _buttonSelected) {
    x=_x;
    y=_y;
    rectWidth = _rectWidth;
    rectHeight = _rectHeight;
    text = _text;
    textX = _textX;
    textY = _textY;


    pressed=_pressed;
    type=_type;
    buttonImage = _buttonImage;
    buttonSelected = _buttonSelected;
  }

  public void draw() {
    pushStyle();


    noStroke();
    buttonImage.resize(rectWidth, rectHeight);
    image(buttonImage, x, y);
    if (pressed==true) {
      buttonSelected.resize(rectWidth, rectHeight);
      image(buttonSelected, x, y);
    }
    if ( overRect()==true) {
      buttonSelected.resize(rectWidth, rectHeight);
      image(buttonSelected, x, y);
    }
    
    textSize(25);
    text(text, textX, textY);

    popStyle();
  }

  //test if mouse is over the button
  public boolean overRect() {
    if (mouseX >= x && mouseX <= x+rectWidth && 
      mouseY >= y && mouseY <= y+rectHeight) {

      return true;
    } else {

      return false;
    }
  }
}

//sets pressed to true and plays a click sound
public void buttonClicked( java.util.LinkedList<Button> buttons ) {
  for (Button b : buttons) {

    if (b.overRect()==true) {
      buttonSound.rewind();
      buttonSound.play();
      b.pressed=true;

      for (Button a_1 : buttons) {
        if (b!=a_1 && a_1.pressed==true) {
          a_1.pressed=false;
        }
      }
    }
  }
}
  public void settings() {  size(1280,720, P3D); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "CleanUp" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
